/*****************************************************************************
 *                              Callback.h
 * 
 * Author: Matthew Ballance
 * Desc:   
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 *****************************************************************************/
#ifndef INCLUDED_CALLBACK_H
#define INCLUDED_CALLBACK_H
#include <tcl.h>
#include "types.h"

class CallbackType;
class CallbackList;
class Callback {

    public:
        Callback(Tcl_ObjCmdProc *cbFunc, void *cbUserData);
       ~Callback();

       int Invoke(Uint32 argc, Tcl_Obj *const objv[]);
       void set_type(CallbackType *type);
       void setList(CallbackList *cbList);

    private:
        CallbackType     *d_type;
        CallbackList     *d_cbList;
        Tcl_ObjCmdProc   *d_cbFunc;
        voidPtr           d_cbUserData;
};

#endif /* INCLUDED_CALLBACK_H */

