/*****************************************************************************
 *                            CallbackList.h
 *
 * Author: Matthew Ballance
 * Desc:   A callback list is associated with each instance of a 
 *         callback-type.
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 *****************************************************************************/
#ifndef INCLUDED_CALLBACK_LIST_H
#define INCLUDED_CALLBACK_LIST_H
#include "types.h"
#include <tcl.h>
#include "vector.h"
#include "ivi_String.h"

class Callback;
class CallbackType;
class CallbackList {
    public:
        CallbackList(const char *instName, CallbackType *type);

        void AddCb(Callback *cb);
        void RemoveCb(Callback *cb);

        int Invoke(Uint32 argc, Tcl_Obj *const objv[]);
        void Enable();
        void Disable();

    private:
        Uint32                   enabled;
        String                   d_instName;
        Vector<Callback>         d_cbList;
};

#endif /* INCLUDED_CALLBACK_LIST_H */
