/****************************************************************************
 *                             DFIOInfo.h
 * Author: Matthew Ballance
 * Desc:   
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 ****************************************************************************/
#ifndef INCLUDED_DFIO_INFO_H
#define INCLUDED_DFIO_INFO_H
#include "DFIO.h"
#include "DFIOTrace.h"
#include "ivi_String.h"
#include <tcl.h>

class DFIOInfo {
    public:
        DFIOInfo(Char *name, Char *desc);

        virtual DFIO *newDFIO(Tcl_Interp *interp, int argc, char **argv) {
            return new DFIO(interp, argc, argv);
        }

        virtual DFIOTrace *newDFIOTrace(
                Char        *name,
                Uint32       rows,
                Uint32       msb,
                Uint32       lsb,
                Uint32       traceType) {
            return new DFIOTrace(name,rows,msb,lsb,traceType);
        }

        const String &getName(void) const { return dfioName; }
        const String &getDesc(void) const { return dfioDesc; }

    private:
        String        dfioName;
        String        dfioDesc;
};

#endif /* INCLUDED_DFIO_INFO_H */

