/*****************************************************************************
 *                               HashEntry.h
 * Author: Matthew Ballance
 * Desc:   Base class for a hash-table entry.
 *
 *
 *
 *
 *
 *
 *
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 *
 *
 *
 *
 *
 *
 *
 *****************************************************************************/
#ifndef INCLUDED_HASH_ENTRY_H
#define INCLUDED_HASH_ENTRY_H
#include "types.h" 

class HashEntry {

    /******************************************************
     * Public methods
     ******************************************************/
public:

    /******************************************************
     * HashEntry()
     ******************************************************/
     HashEntry(
         Char        *name
     );

    /******************************************************
     * hash()
     ******************************************************/
     virtual Uint32 hash(
         Uint32        tableSize
         );

    /******************************************************
     * compare()
     ******************************************************/
     virtual Int32 compare(
         HashEntry       *e2
         );

     static Int32 compare(HashEntry *e, const char *key);

    /******************************************************
     * hash()
     ******************************************************/
     static Uint32 hash(const char *str, Uint32 tableSize);

    /******************************************************
     * keyVal()
     ******************************************************/
     Char *keyVal(void) {
         return entryName;
     }
 
    HashEntry   *nextEntry; 

private: 
    Char        *entryName;
};

#endif /*INCLUDED_HASH_ENTRY_H*/
