/****************************************************************************
 *                            LogRegionType.cc
 * 
 * Author: Matthew Ballance
 * Desc:   Implements the base logging region type... This type may be 
 *         extended...
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 ****************************************************************************/
#include "LogRegionType.h"

/********************************************************************
 * LogRegionType()
 ********************************************************************/
LogRegionType::LogRegionType(const char *typeName) :
    regionTypeName(typeName), shortDesc(64), longDesc(128), lowDbgDesc(64),
    medDbgDesc(64), highDbgDesc(64)
{

}

/********************************************************************
 * LogRegionType()
 ********************************************************************/
LogRegionType::LogRegionType(
        const char         *typeNameStr,
        const char         *shortDescStr,
        const char         *lowDbgDescStr,
        const char         *medDbgDescStr,
        const char         *highDbgDescStr) :
    regionTypeName(typeNameStr), shortDesc(shortDescStr), longDesc(128),
    lowDbgDesc(lowDbgDescStr), medDbgDesc(medDbgDescStr),
    highDbgDesc(highDbgDescStr)
{

}

/********************************************************************
 * LogRegionType()
 *
 * Copy constructor... Used by LogInstance...
 ********************************************************************/
LogRegionType::LogRegionType(LogRegionType *rType) :
    mgr(rType->mgr), regionTypeName(rType->regionTypeName),
    shortDesc(rType->shortDesc), longDesc(rType->shortDesc),
    lowDbgDesc(rType->lowDbgDesc), medDbgDesc(rType->medDbgDesc),
    highDbgDesc(rType->highDbgDesc)
{

}



