
#ifndef INCLUDED_TCL_OLD_CONFIG_H
#define INCLUDED_TCL_OLD_CONFIG_H

extern "C" int Tcl_ConfigureWidget(
    Tcl_Interp *interp,		/* Interpreter for error reporting. */
    Tk_Window tkwin,		/* Window containing widget (needed to
				 * set up X resources). */
    Tk_ConfigSpec *specs,	/* Describes legal options. */
    int argc,			/* Number of elements in argv. */
    char **argv,		/* Command-line options. */
    char *widgRec,		/* Record whose fields are to be
				 * modified.  Values must be properly
				 * initialized. */
    int flags);			/* Used to specify additional flags
				 * that must be present in config specs
				 * for them to be considered.  Also,
				 * may have TK_CONFIG_ARGV_ONLY set. */

extern "C" int Tcl_ConfigureInfo(
    Tcl_Interp *interp,		/* Interpreter for error reporting. */
    Tk_Window tkwin,		/* Window corresponding to widgRec. */
    Tk_ConfigSpec *specs,	/* Describes legal options. */
    char *widgRec,		/* Record whose fields contain current
				 * values for options. */
    char *argvName,		/* If non-NULL, indicates a single option
				 * whose info is to be returned.  Otherwise
				 * info is returned for all options. */
    int flags);			/* Used to specify additional flags
				 * that must be present in config specs
				 * for them to be considered. */
extern "C" int Tcl_ConfigureValue(
    Tcl_Interp *interp,		/* Interpreter for error reporting. */
    Tk_Window tkwin,		/* Window corresponding to widgRec. */
    Tk_ConfigSpec *specs,	/* Describes legal options. */
    char *widgRec,		/* Record whose fields contain current
				 * values for options. */
    char *argvName,		/* Gives the command-line name for the
				 * option whose value is to be returned. */
    int flags);			/* Used to specify additional flags
				 * that must be present in config specs
				 * for them to be considered. */

#endif /* INCLUDED_TCL_OLD_CONFIG_H */
