/*****************************************************************************
 *                              tree_field.h
 * Author: Matthew Ballance
 * Desc:   Implements a field within a tree
 *
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 *
 *****************************************************************************/
#ifndef INCLUDED_TREE_FIELD_H
#define INCLUDED_TREE_FIELD_H
#include "ivi_String.h"
#include "types.h"

class TreeField {

public:

    TreeField(char *fieldName, char *initValue);
    TreeField(char *fieldName, void *initVValue);
    TreeField(TreeField *templ);
   ~TreeField(void);

    inline void *getVoidVal(void) { return fieldVoidVal; }
    inline String *getStringVal(void) {return fieldValue; }

    inline void setVoidVal(void *val) { fieldVoidVal = val; }
    inline void setStringVal(char *val) { *fieldValue = val; }
    
    String    *fieldName;
private:
    String    *fieldValue;
    void      *fieldVoidVal; 
};

#endif /*INCLUDED_TREE_FIELD_H*/


