/****************************************************************************
 *                           GhdlRemoteSimInfo.h
 *
 * Author: Matthew Ballance
 * Desc:   Provides info on the GHDL remote interface to the IVI runtime
 * <Copyright> (c) 2001-2003 Matthew Ballance (mballance@users.sourceforge.net)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * </Copyright>
 ****************************************************************************/
#ifndef INCLUDED_GHDL_REMOTE_SIM_INFO_H
#define INCLUDED_GHDL_REMOTE_SIM_INFO_H
#include "SimInfo.h"

class GhdlRemoteSimInfo : public SimInfo {

    /****************************************************************
     * Public Methods
     ****************************************************************/
    public:

        /************************************************************
         */
        /** GhdlRemoteSimInfo()
         ************************************************************/
        GhdlRemoteSimInfo(Tcl_Interp *interp);

        /************************************************************
         * newSim()
         */
        /**
         * Creates a new simulator instance
         ************************************************************/
        virtual IviSim *newSim(Tcl_Interp *interp, int argc, char **argv);

};
#endif /* INCLUDED_GHDL_REMOTE_SIM_INFO_H */
